# Solvers
```@meta
CurrentModule = TrajectoryOptimization
```

```@contents
Pages = ["solvers.md"]
```

## Iterative LQR (iLQR)
```@docs
iLQRSolver
iLQRSolverOptions
```

## Augmented Lagrangian Solver
```@docs
AugmentedLagrangianSolver
AugmentedLagrangianSolverOptions
```


## ALTRO
```@docs
ALTROSolver
ALTROSolverOptions
```

## Direct Collocation (DIRCOL)
```@docs
DIRCOLSolver
DIRCOLSolverOptions
```

## Projected Newton
```@docs
ProjectedNewtonSolver
ProjectedNewtonSolverOptions
```
